| Version: 3.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
wxArtProvider Class Reference
Class List by Category » Miscellaneous

`#include <wx/artprov.h>`

Inheritance diagram for wxArtProvider:
[legend]

## Detailed Description

wxArtProvider class is used to customize the look of wxWidgets application.

When wxWidgets needs to display an icon or a bitmap (e.g. in the standard file dialog), it does not use a hard-coded resource but asks wxArtProvider for it instead. This way users can plug in their own wxArtProvider class and easily replace standard art with their own version.

All that is needed is to derive a class from wxArtProvider, override either its wxArtProvider::CreateBitmap() and/or its wxArtProvider::CreateIconBundle() methods and register the provider with wxArtProvider::Push():

class MyProvider : public wxArtProvider
{
protected:
// Override this method to return a bundle containing the required
// bitmap in all available sizes.
wxBitmapBundle CreateBitmapBundle(const wxArtID& id,
const wxArtClient& client,
const wxSize& size) override;
// If all bitmaps are available in a single size only, it may be
// simpler to override just this one.
wxBitmap CreateBitmap(const wxArtID& id,
const wxArtClient& client,
const wxSize& size) override;
// optionally override this one as well
wxIconBundle CreateIconBundle(const wxArtID& id,
const wxArtClient& client) override;
{ ... }
};
...
wxArtProvider::Push(new MyProvider);
wxArtProvider
wxArtProvider class is used to customize the look of wxWidgets application.
Definition: artprov.h:274
wxArtProvider::CreateIconBundle
virtual wxIconBundle CreateIconBundle(const wxArtID &id, const wxArtClient &client)
This method is similar to CreateBitmap() but can be used when a bitmap (or an icon) exists in several...
wxArtProvider::CreateBitmapBundle
virtual wxBitmapBundle CreateBitmapBundle(const wxArtID &id, const wxArtClient &client, const wxSize &size)
Override this method to create the requested art resources available in more than one size.
wxArtProvider::CreateBitmap
virtual wxBitmap CreateBitmap(const wxArtID &id, const wxArtClient &client, const wxSize &size)
Derived art provider classes may override this method to create requested art resource.
wxBitmapBundle
Contains representations of the same bitmap in different resolutions.
Definition: bmpbndl.h:100
wxBitmap
This class encapsulates the concept of a platform-dependent bitmap, either monochrome or colour or co...
Definition: bitmap.h:212
wxIconBundle
This class contains multiple copies of an icon in different sizes.
Definition: iconbndl.h:21
wxSize
A wxSize is a useful data structure for graphics operations.
Definition: gdicmn.h:1039
wxString
String class for passing textual data to or receiving it from wxWidgets.
Definition: string.h:372

Note that, as usual in wxWidgets API, wxArtProvider takes ownership of the pointer and will destroy it on program shutdown. In particular, you should not delete this pointer in your own code.

If you need bitmap images (of the same artwork) that should be displayed at different sizes you should probably consider overriding wxArtProvider::CreateIconBundle and supplying icon bundles that contain different bitmap sizes.

There's another way of taking advantage of this class: you can use it in your code and use platform native icons as provided by wxArtProvider::GetBitmapBundle or wxArtProvider::GetIcon.

# Identifying art resources

Every bitmap and icon bundle are known to wxArtProvider under a unique ID that is used when requesting a resource from it. The ID is represented by the wxArtID type and can have one of these predefined values (you can see bitmaps represented by these constants in the Art Provider Sample):

`wxART_ERROR` `wxART_QUESTION` `wxART_WARNING` `wxART_INFORMATION` `wxART_ADD_BOOKMARK` `wxART_DEL_BOOKMARK` `wxART_HELP_SIDE_PANEL` `wxART_HELP_SETTINGS` `wxART_HELP_BOOK` `wxART_HELP_FOLDER` `wxART_HELP_PAGE` `wxART_GO_BACK` `wxART_GO_FORWARD` `wxART_GO_UP` `wxART_GO_DOWN` `wxART_GO_TO_PARENT` `wxART_GO_HOME` `wxART_GOTO_FIRST` (since 2.9.2) | `wxART_GOTO_LAST` (since 2.9.2) `wxART_PRINT` `wxART_HELP` `wxART_TIP` `wxART_REPORT_VIEW` `wxART_LIST_VIEW` `wxART_NEW_DIR` `wxART_FOLDER` `wxART_FOLDER_OPEN` `wxART_GO_DIR_UP` `wxART_EXECUTABLE_FILE` `wxART_NORMAL_FILE` `wxART_TICK_MARK` `wxART_CROSS_MARK` `wxART_MISSING_IMAGE` `wxART_NEW` `wxART_FILE_OPEN` `wxART_FILE_SAVE` | `wxART_FILE_SAVE_AS` `wxART_DELETE` `wxART_COPY` `wxART_CUT` `wxART_PASTE` `wxART_UNDO` `wxART_REDO` `wxART_PLUS` (since 2.9.2) `wxART_MINUS` (since 2.9.2) `wxART_CLOSE` `wxART_QUIT` `wxART_FIND` `wxART_FIND_AND_REPLACE` `wxART_FULL_SCREEN` (since 3.1.0) `wxART_EDIT` (since 3.1.0) `wxART_HARDDISK` `wxART_FLOPPY` `wxART_CDROM` `wxART_REMOVABLE` `wxART_WX_LOGO` (since 3.1.6)

Note
  When building with `wxNO_IMPLICIT_WXSTRING_ENCODING` defined (see wxString Overview for more details), you need to explicitly use wxASCII_STR() around these constants.

Additionally, any string recognized by custom art providers registered using wxArtProvider::Push may be used.

Note
  When running under GTK+ 2, GTK+ stock item IDs (e.g. `"gtk-cdrom"`) may be used as well:
  #ifdef __WXGTK__
  wxBitmap bmp = wxArtProvider::GetBitmap("gtk-cdrom", wxART_MENU);
  #endif
  wxART_MENU
  const char * wxART_MENU
  Definition: artprov.h:20
  wxArtProvider::GetBitmap
  static wxBitmap GetBitmap(const wxArtID &id, const wxArtClient &client=wxART_OTHER, const wxSize &size=wxDefaultSize)
  Query registered providers for bitmap with given ID.
  For a list of the GTK+ stock items please refer to the GTK+ documentation page. It is also possible to load icons from the current icon theme by specifying their name (without extension and directory components). Icon themes recognized by GTK+ follow the freedesktop.org Icon Themes specification. Note that themes are not guaranteed to contain all icons, so wxArtProvider may return wxNullBitmap or wxNullIcon. The default theme is typically installed in `/usr/share/icons/hicolor`.

# Clients

The client is the entity that calls wxArtProvider's GetBitmap() or GetIcon() function. It is represented by wxClientID type and can have one of these values:

- `wxART_TOOLBAR`
- `wxART_MENU`
- `wxART_BUTTON`
- `wxART_FRAME_ICON`
- `wxART_CMN_DIALOG`
- `wxART_HELP_BROWSER`
- `wxART_MESSAGE_BOX`
- `wxART_OTHER` (used for all requests that don't fit into any of the categories above)

Client ID serve as a hint to wxArtProvider that is supposed to help it to choose the best looking bitmap. For example it is often desirable to use slightly different icons in menus and toolbars even though they represent the same action (e.g. wxART_FILE_OPEN). Remember that this is really only a hint for wxArtProvider – it is common that wxArtProvider::GetBitmap returns identical bitmap for different client values!

##

Library: wxCore
Category: Miscellaneous

See also
  Art Provider Sample for an example of wxArtProvider usage; stock ID list

## Public Member Functions
virtual | ~wxArtProvider ()
| The destructor automatically removes the provider from the provider stack used by GetBitmap(). More...
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to nullptr the internal reference data. More...
| wxObject (const wxObject &other)
| Copy ctor. More...
virtual | ~wxObject ()
| Destructor. More...
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar). More...
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object. More...
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class. More...
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj. More...
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone. More...
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer. More...
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data. More...
void | UnShare ()
| This is the same of AllocExclusive() but this method is public. More...
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...
void * | operator new (size_t size, const wxString &filename=nullptr, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `__WXDEBUG__` is defined. More...

## Static Public Member Functions
static bool | Delete (wxArtProvider *provider)
| Delete the given provider. More...
static wxBitmap | GetBitmap (const wxArtID &id, const wxArtClient &client=wxART_OTHER, const wxSize &size=wxDefaultSize)
| Query registered providers for bitmap with given ID. More...
static wxBitmapBundle | GetBitmapBundle (const wxArtID &id, const wxArtClient &client=wxART_OTHER, const wxSize &size=wxDefaultSize)
| Query registered providers for a bundle of bitmaps with given ID. More...
static wxIcon | GetIcon (const wxArtID &id, const wxArtClient &client=wxART_OTHER, const wxSize &size=wxDefaultSize)
| Same as wxArtProvider::GetBitmap, but return a wxIcon object (or wxNullIcon on failure). More...
static wxSize | GetNativeDIPSizeHint (const wxArtClient &client)
| Returns native icon size for use specified by client hint in DIPs. More...
static wxSize | GetNativeSizeHint (const wxArtClient &client, wxWindow *win=nullptr)
| Returns native icon size for use specified by client hint. More...
static wxSize | GetDIPSizeHint (const wxArtClient &client)
| Returns a suitable size hint for the given wxArtClient in DIPs. More...
static wxSize | GetSizeHint (const wxArtClient &client, wxWindow *win=nullptr)
| Returns a suitable size hint for the given wxArtClient. More...
static wxIconBundle | GetIconBundle (const wxArtID &id, const wxArtClient &client=wxART_OTHER)
| Query registered providers for icon bundle with given ID. More...
static bool | HasNativeProvider ()
| Returns true if the platform uses native icons provider that should take precedence over any customizations. More...
static void | Insert (wxArtProvider *provider)
static bool | Pop ()
| Remove latest added provider and delete it. More...
static void | Push (wxArtProvider *provider)
| Register new art provider and add it to the top of providers stack (i.e. More...
static void | PushBack (wxArtProvider *provider)
| Register new art provider and add it to the bottom of providers stack. More...
static bool | Remove (wxArtProvider *provider)
| Remove a provider from the stack if it is on it. More...
static wxArtID | GetMessageBoxIconId (int flags)
| Helper used by GetMessageBoxIcon(): return the art id corresponding to the standard wxICON_INFORMATION/WARNING/ERROR/QUESTION flags (only one can be set) More...
static wxIcon | GetMessageBoxIcon (int flags)
| Helper used by several generic classes: return the icon corresponding to the standard wxICON_INFORMATION/WARNING/ERROR/QUESTION flags (only one can be set) More...

## Protected Member Functions
virtual wxSize | DoGetSizeHint (const wxArtClient &client)
| Derived art provider classes may override this method to return the size of the images used by this provider. More...
virtual wxBitmap | CreateBitmap (const wxArtID &id, const wxArtClient &client, const wxSize &size)
| Derived art provider classes may override this method to create requested art resource. More...
virtual wxBitmapBundle | CreateBitmapBundle (const wxArtID &id, const wxArtClient &client, const wxSize &size)
| Override this method to create the requested art resources available in more than one size. More...
virtual wxIconBundle | CreateIconBundle (const wxArtID &id, const wxArtClient &client)
| This method is similar to CreateBitmap() but can be used when a bitmap (or an icon) exists in several sizes. More...
Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object. More...
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it. More...
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data. More...

## Additional Inherited Members
Protected Attributes inherited from wxObject
wxObjectRefData * | m_refData
| Pointer to an object which is the object's reference-counted data. More...

## Constructor & Destructor Documentation

## ◆ ~wxArtProvider()

virtual wxArtProvider::~wxArtProvider | ( |  | ) |
| virtual

The destructor automatically removes the provider from the provider stack used by GetBitmap().

## Member Function Documentation

## ◆ CreateBitmap()

virtual wxBitmap wxArtProvider::CreateBitmap | ( | const wxArtID & | id,
|  | const wxArtClient & | client,
|  | const wxSize & | size
| ) |  |
| protected virtual

Derived art provider classes may override this method to create requested art resource.

For bitmaps available in more than one size, CreateBitmapBundle() should be overridden instead.

Note that returned bitmaps are cached by wxArtProvider and it is therefore not necessary to optimize CreateBitmap() for speed (e.g. you may create wxBitmap objects from XPMs here).

Parameters

  id | wxArtID unique identifier of the bitmap.
  client | wxArtClient identifier of the client (i.e. who is asking for the bitmap). This only serves as a hint.
  size | Preferred size of the bitmap. The function may return a bitmap of different dimensions, it will be automatically rescaled to meet client's request.

Note
  This is not part of wxArtProvider's public API, use wxArtProvider::GetBitmap or wxArtProvider::GetIconBundle or wxArtProvider::GetIcon to query wxArtProvider for a resource.

See also
  CreateIconBundle()

## ◆ CreateBitmapBundle()

virtual wxBitmapBundle wxArtProvider::CreateBitmapBundle | ( | const wxArtID & | id,
|  | const wxArtClient & | client,
|  | const wxSize & | size
| ) |  |
| protected virtual

Override this method to create the requested art resources available in more than one size.

Unlike CreateBitmap(), this method can be overridden to return the same bitmap in several (or all, if wxBitmapBundle::FromSVG() is used) sizes at once, which will allow selecting the size best suited for the current display resolution automatically.

Parameters

  id | wxArtID unique identifier of the bitmap.
  client | wxArtClient identifier of the client (i.e. who is asking for the bitmap). This only serves as a hint.
  size | Default size of the bitmaps returned by the bundle.

Since
  3.1.6

## ◆ CreateIconBundle()

virtual wxIconBundle wxArtProvider::CreateIconBundle | ( | const wxArtID & | id,
|  | const wxArtClient & | client
| ) |  |
| protected virtual

This method is similar to CreateBitmap() but can be used when a bitmap (or an icon) exists in several sizes.

## ◆ Delete()

static bool wxArtProvider::Delete | ( | wxArtProvider * | provider | ) |
| static

Delete the given provider.

## ◆ DoGetSizeHint()

virtual wxSize wxArtProvider::DoGetSizeHint | ( | const wxArtClient & | client | ) |
| protected virtual

Derived art provider classes may override this method to return the size of the images used by this provider.

Note that the returned size should be in DPI-independent pixels, i.e. DIPs. The default implementation returns the result of GetNativeDIPSizeHint().

## ◆ GetBitmap()

static wxBitmap wxArtProvider::GetBitmap | ( | const wxArtID & | id,
|  | const wxArtClient & | client = `wxART_OTHER`,
|  | const wxSize & | size = `wxDefaultSize`
| ) |  |
| static

Query registered providers for bitmap with given ID.

Note that applications using wxWidgets 3.1.6 or later should prefer calling GetBitmapBundle().

Parameters

  id | wxArtID unique identifier of the bitmap.
  client | wxArtClient identifier of the client (i.e. who is asking for the bitmap).
  size | Size of the returned bitmap or wxDefaultSize if size doesn't matter.

Returns
  The bitmap if one of registered providers recognizes the ID or wxNullBitmap otherwise.

## ◆ GetBitmapBundle()

static wxBitmapBundle wxArtProvider::GetBitmapBundle | ( | const wxArtID & | id,
|  | const wxArtClient & | client = `wxART_OTHER`,
|  | const wxSize & | size = `wxDefaultSize`
| ) |  |
| static

Query registered providers for a bundle of bitmaps with given ID.

Since
  3.1.6

Parameters

  id | wxArtID unique identifier of the bitmap.
  client | wxArtClient identifier of the client (i.e. who is asking for the bitmap).
  size | Default size for the returned bundle, i.e. the size of the bitmap in normal DPI (this implies that wxWindow::FromDIP() must not be used with it).

Returns
  If any of the registered providers recognizes the ID in its CreateBitmapBundle(), this bundle is returned. Otherwise, if any of providers returns a valid bitmap from CreateBitmap(), the bundle containing only this bitmap is returned. Otherwise, an empty bundle is returned.

## ◆ GetDIPSizeHint()

static wxSize wxArtProvider::GetDIPSizeHint | ( | const wxArtClient & | client | ) |
| static

Returns a suitable size hint for the given wxArtClient in DIPs.

Return the size used by the topmost wxArtProvider for the given client. wxDefaultSize may be returned if the client doesn't have a specified size, like wxART_OTHER for example.

See also
  GetNativeDIPSizeHint()

## ◆ GetIcon()

static wxIcon wxArtProvider::GetIcon | ( | const wxArtID & | id,
|  | const wxArtClient & | client = `wxART_OTHER`,
|  | const wxSize & | size = `wxDefaultSize`
| ) |  |
| static

Same as wxArtProvider::GetBitmap, but return a wxIcon object (or wxNullIcon on failure).

## ◆ GetIconBundle()

static wxIconBundle wxArtProvider::GetIconBundle | ( | const wxArtID & | id,
|  | const wxArtClient & | client = `wxART_OTHER`
| ) |  |
| static

Query registered providers for icon bundle with given ID.

Parameters

  id | wxArtID unique identifier of the icon bundle.
  client | wxArtClient identifier of the client (i.e. who is asking for the icon bundle).

Returns
  The icon bundle if one of registered providers recognizes the ID or wxNullIconBundle otherwise.

## ◆ GetMessageBoxIcon()

static wxIcon wxArtProvider::GetMessageBoxIcon | ( | int | flags | ) |
| static

Helper used by several generic classes: return the icon corresponding to the standard wxICON_INFORMATION/WARNING/ERROR/QUESTION flags (only one can be set)

## ◆ GetMessageBoxIconId()

static wxArtID wxArtProvider::GetMessageBoxIconId | ( | int | flags | ) |
| static

Helper used by GetMessageBoxIcon(): return the art id corresponding to the standard wxICON_INFORMATION/WARNING/ERROR/QUESTION flags (only one can be set)

## ◆ GetNativeDIPSizeHint()

static wxSize wxArtProvider::GetNativeDIPSizeHint | ( | const wxArtClient & | client | ) |
| static

Returns native icon size for use specified by client hint in DIPs.

If the platform has no commonly used default for this use or if client is not recognized, returns wxDefaultSize.

Note
  In some cases, a platform may have several appropriate native sizes (for example, wxART_FRAME_ICON for frame icons). In that case, this method returns only one of them, picked reasonably.

Since
  3.1.6

## ◆ GetNativeSizeHint()

static wxSize wxArtProvider::GetNativeSizeHint | ( | const wxArtClient & | client,
|  | wxWindow * | win = `nullptr`
| ) |  |
| static

Returns native icon size for use specified by client hint.

This function does the same thing as GetNativeDIPSizeHint(), but uses win to convert the returned value to logical pixels. If win is nullptr, default DPI scaling (i.e. that of the primary display) is used.

Since
  2.9.0 (win parameter is available only since 3.1.6)

## ◆ GetSizeHint()

static wxSize wxArtProvider::GetSizeHint | ( | const wxArtClient & | client,
|  | wxWindow * | win = `nullptr`
| ) |  |
| static

Returns a suitable size hint for the given wxArtClient.

This function does the same thing as GetDIPSizeHint(), but uses win to convert the returned value to logical pixels. If win is nullptr, default DPI scaling (i.e. that of the primary display) is used.

Note that win parameter is only available since wxWidgets 3.1.6.

## ◆ HasNativeProvider()

static bool wxArtProvider::HasNativeProvider | ( |  | ) |
| static

Returns true if the platform uses native icons provider that should take precedence over any customizations.

This is true for any platform that has user-customizable icon themes, currently only wxGTK.

A typical use for this method is to decide whether a custom art provider should be plugged in using Push() or PushBack().

Since
  2.9.0

## ◆ Insert()

static void wxArtProvider::Insert | ( | wxArtProvider * | provider | ) |
| static

Deprecated:
  Use PushBack() instead.

## ◆ Pop()

static bool wxArtProvider::Pop | ( |  | ) |
| static

Remove latest added provider and delete it.

## ◆ Push()

static void wxArtProvider::Push | ( | wxArtProvider * | provider | ) |
| static

Register new art provider and add it to the top of providers stack (i.e.

it will be queried as the first provider).

Parameters

  provider | A valid pointer that becomes owned by wxArtProvider.

See also
  PushBack()

## ◆ PushBack()

static void wxArtProvider::PushBack | ( | wxArtProvider * | provider | ) |
| static

Register new art provider and add it to the bottom of providers stack.

In other words, it will be queried as the last one, after all others, including the default provider.

Parameters

  provider | A valid pointer that becomes owned by wxArtProvider.

See also
  Push()

Since
  2.9.0

## ◆ Remove()

static bool wxArtProvider::Remove | ( | wxArtProvider * | provider | ) |
| static

Remove a provider from the stack if it is on it.

The provider is not deleted, unlike when using Delete().